!-------------------------------------------------
!   area3.f90    ver. 3
!   Marking region of interest for DEM
!    K. Suzuki, Niigata University
!   2024B3684, 9 November,2024
!--------------------------------------------------

program area
  implicit none
  
  character:: filename*50,file2*50
  integer:: i,j,m,n,w,h
  real*4:: x(0:2000,0:2000)
  integer:: roi(0:2000,0:2000)=0
  !   tthは2θアームの角度，thは材料の2θ0．
  real*4:: phi, r, tth=8.23, pi=3.14159,dphi,dth,th=8.21, d2th
  real*4:: l=400.0, l0=500,x1,z1,a=0.2
  real*4:: x01=108.240,y01=68.987,x02=113.234,y02=68.572 !これはピクセル値
  integer:: ox,oy,n1,n2


  w=200;h=190  ! 画像サイズ for CdTe                  w=0:200 h=0:190
  n1=20; n2=100 !分割数  n1: 2θ，n2: φ方位角
  dth = 0.20/float(n1)   ! 2θ幅 0.28 deg
  dphi = 7.0/float(n2)   !+/- 7.0 deg
  d2th=(th-tth)*pi/180.0
  
  print *,"filename"
  read(5,*) filename

  
  open(unit=11,file=filename,status='old')
    do j=0,h
      read(11,*) (x(i,j),i=0,w)
    end do
  close(11)
  
  print *,' 回折半径が検出器y方向: P1 = 1, P2 = 2'
  print *,' 回折半径が検出器x方向: P1 = 3, P2 = 4　　縦振り2θアームの場合は1, 2を選択'
  print *,'読み込んだ画像のタイプの番号を入れてください．'
  read(5,*) m
  


  if (m == 1) then  !　P1hの場合 検出器水平方向x, 垂直方向y
    do j=-n1,n1
      do i=-n2,n2
        r= l0*cos(tth*pi/180.)*tan(pi/180.0*(th+dth*real(j)))
        phi= pi/180.0*dphi*real(i)
        x1 = r*sin(phi); z1 = r*cos(phi)   !experimental space
        !実験室座標から検出器座標ox,oyへ
        ox=nint(x01-x1/a)
        oy=nint(y01 +cos(tth*pi/180.0)/a*(l0*sin(tth*pi/180)-z1))
        if (roi(ox,oy) == 0) then
          roi(ox,oy) = 1
        end if
      end do
    end do
  end if
  
  if (m == 2) then  !　P2hの場合 検出器水平方向x, 垂直方向y
    do j=-n1,n1
      do i=-n2,n2
        r= (l0+l)*cos(tth*pi/180.)*tan(pi/180.0*(th+dth*real(j)))+l*tan(d2th)
        phi= pi/180.0*dphi*real(i)
        x1 = r*sin(phi); z1 = r*cos(phi)   !experimental space
        !実験室座標から検出器座標ox,oyへ
        ox=nint(x02-x1/a)
        oy=nint(y02 +cos(tth*pi/180.0)/a*((l0+l)*sin(tth*pi/180)-z1))
        if (roi(ox,oy) == 0) then
          roi(ox,oy) = 1
        end if
      end do
    end do
  end if
  

  if (m == 3) then  !　P1rの場合 検出器水平方向y, 垂直方向x
    do j=-n1,n1
      do i=-n2,n2
        r= l0*cos(tth*pi/180.)*tan(pi/180.0*(th+dth*real(j)))
        phi= pi/180.0*dphi*real(i)
        z1 = -r*sin(phi); x1 = r*cos(phi)   !experimental space
        !実験室座標から検出器座標ox,oyへ
        ox=nint(x01-z1/a)
        oy=nint(y01 +cos(tth*pi/180.0)/a*(l0*sin(tth*pi/180)-x1))
        if (roi(ox,oy) == 0) then
          roi(ox,oy) = 1
        end if
      end do
    end do
  end if

  
  if (m == 4) then  !　P2rの場合 検出器水平方向y, 垂直方向x
    do j=-n1,n1
      do i=-n2,n2
        r= (l0+l)*cos(tth*pi/180.)*tan(pi/180.0*(th+dth*real(j)))
        phi= pi/180.0*dphi*real(i)
        z1 = r*sin(phi); x1 = r*cos(phi)   !experimental space
        !実験室座標から検出器座標ox,oyへ
        ox=nint(x02-z1/a)
        oy=nint(y02 +cos(tth*pi/180.0)/a*((l0+l)*sin(tth*pi/180)-x1))+l*tan(d2th)
        if (roi(ox,oy) == 0) then
          roi(ox,oy) = 1
        end if
      end do
    end do
  end if
  ! --------------- Paint ROI -------------
  do j=0,h
    do i=0,w
      if(roi(i,j) == 1) then
        x(i,j)=x(i,j) + 30.0
      end if
    end do
  end do
  
  file2="ROI_"//trim(adjustl(filename))
    open(unit=12,file=file2,status='unknown')
    do j=0,h
      write(12,*) (x(i,j),i=0,w)
    end do
  close(12)
  
  end program area